using System;
using System.Collections.Generic;
using System.Security.Cryptography;
using System.Text;
using System.Threading;

namespace hackaday
{
	class MainClass
	{
		static int MaxLetters;
		static string HashToMatch;
		static bool FoundMatch;
		
		static List<Thread> Threads = new List<Thread>();
		
		public static void Main(string[] args)
		{
			if (args.Length != 2) {
				// bail out!
				return;
			}

			MaxLetters = Convert.ToInt32(args[0]);
			HashToMatch = args[1];


			int StartTime = Environment.TickCount;

			for (int i = 0; i < 26; ++i) {
				Thread thread = new Thread(DoFunk);
				thread.Name = Convert.ToString(i);
				thread.Start(Convert.ToChar(Convert.ToInt32('a') + i));
				Threads.Add(thread);
			}

			foreach (Thread thread in Threads) {
				thread.Join();
			}

			int EndTime = Environment.TickCount;

			float ExecTime = (EndTime - StartTime);
			ExecTime = ExecTime / 1000;

			Console.WriteLine("Execution took " + ExecTime + " seconds.");
		}
		
		static void DoFunk(object startletter)
		{
			char start = (char)startletter;

			NextLetter(start.ToString(), 2);
		}
		
		static void NextLetter(string start, int level)
		{
			string p;
			string sha;

			if (level <= MaxLetters)
			{
				for (int i = 0; i < 26; ++i)
				{
					if (FoundMatch) return;

					p = start + Convert.ToChar(Convert.ToInt32('a') + i);
					sha = Sha1(p);

					if (HashToMatch == sha)
					{
						FoundMatch = true;
						Console.WriteLine("*** Thread " + Thread.CurrentThread.Name + " found match: " + p + ": " + sha);
					}
					else
					{
						Console.WriteLine("Thread " + Thread.CurrentThread.Name + " failed match " + p + ": " + sha);
					}

					NextLetter(p, level + 1);
				}
			}
		}

		public static string Sha1(string input)
		{
			SHA1CryptoServiceProvider Sha1Crypto = new SHA1CryptoServiceProvider();
			byte[] hash = Sha1Crypto.ComputeHash(Encoding.Default.GetBytes(input));
			string result = "";
			foreach (byte b in hash) result += b.ToString("x2");
			return result;
		}
	}
}